/*
    Programiranje(C) - 30. lipnja 2003. [Matko Botincan]
    -----
    1. zadatak
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

void check(void* p) {
    if(p == NULL) {
        printf("Greska u alokaciji memorije!\n");
        exit(1);
    }   
}

int je_prost(int n) {
    int i;
    
    for (i=2; i<(int)sqrt(n)+1; i++)
        if (n%i==0) return 0;
        
    return 1;
}

int main() {
    int n, i, j;
    int** A;
    
    printf("Unesite prirodan broj: ");
    scanf("%d", &n);

    A = (float**) malloc(n*sizeof(float*));
    check(A);
    for (i=0; i<n; i++) {
        A[i]= (float*) malloc(n*sizeof(float));
        check(A[i]);
    }

    for(i=0; i<n; i++)
        for(j=0; j<n; j++) {
            printf("A[%d][%d]=", i, j);
            scanf("%d", &A[i][j]);
        }

    for(i=0; i<n; i++)
        for(j=0; j<n; j++)
            if(je_prost(A[i][j]))
                printf("A[%d][%d]=%d je prost.\n", i, j, A[i][j]);

    for (i=0; i<n; i++)
        free(A[i]);
    free(A);

    return 0;
}
