/*
    Programiranje(C) - 30. lipnja 2003. [Matko Botincan]
    -----
    4. zadatak
*/

#include <stdio.h>
#include <string.h>

typedef struct _cvor {
    char* string;
    struct _cvor* next;
} cvor;

cvor* ubaci(cvor* glava, char* s) {
    cvor *pomocni, *prethodni, *trenutni;

    pomocni=(cvor*) malloc(sizeof(cvor));
    pomocni->string=(char*) malloc(sizeof(char)*(strlen(s)+1));
    strcpy(pomocni->string, s);
    trenutni=glava;
    prethodni=NULL;
    while(trenutni!=NULL && strcmp(trenutni->string, s)<0) {
        prethodni=trenutni;
        trenutni=trenutni->next;
    }

    if(prethodni==NULL) {
        pomocni->next=glava;
        glava=pomocni;
    }
    else {
        pomocni->next=trenutni;
        prethodni->next=pomocni;
    }
    return glava;
}

int main() {
    cvor *glava=NULL, *pomocni;
    char foo[256];
    
    while(1) {
        printf ("Unesi string (0 za kraj): ");
        scanf ("%s", foo);
        if(!strcmp(foo, "0"))
            break;
        glava=ubaci(glava, foo);
    }

    printf("Ispis liste: ");
    for(pomocni=glava; pomocni!=NULL; pomocni=pomocni->next)
        printf("%s ", pomocni->string);

    while(glava!=NULL) {
        pomocni=glava;
        glava=glava->next;
        free(pomocni->string);
        free(pomocni);
    }
        
    return 0;   
}

