/*
    Programiranje(C) - 30. lipnja 2003. [Matko Botincan]
    -----
    5. zadatak
*/

#include <stdio.h>
#include <string.h>

typedef struct _cvor {
    char* string;
    struct _cvor* next;
} cvor;

cvor* ubaci1(cvor* glava, char* s) {
    cvor *pomocni, *prethodni, *trenutni;

    pomocni=(cvor*) malloc(sizeof(cvor));
    pomocni->string=(char*) malloc(sizeof(char)*(strlen(s)+1));
    strcpy(pomocni->string, s);
    trenutni=glava;
    prethodni=NULL;
    while(trenutni!=NULL && strcmp(trenutni->string, s)<0) {
        prethodni=trenutni;
        trenutni=trenutni->next;
    }
    if(trenutni!=NULL && strcmp(trenutni->string, s)==0)
        return glava;
    if(prethodni==NULL) {
        pomocni->next=glava;
        glava=pomocni;
    }
    else {
        pomocni->next=trenutni;
        prethodni->next=pomocni;
    }
    return glava;
}

int main(int argc, char* argv[]) {
    cvor *glava=NULL, *pomocni;
    int i;

    for(i=0; i<argc; i++)
        glava=ubaci1(glava, argv[i]);

    printf("Ispis liste: ");
    for(pomocni=glava, i=0; pomocni!=NULL; pomocni=pomocni->next, i++)
        printf("%s ", pomocni->string);

    printf("\nBroj medjusobno razlicitih argumenata komandne linije je: %d\n", i);

    while(glava!=NULL) {
        pomocni=glava;
        glava=glava->next;
        free(pomocni->string);
        free(pomocni);
    }
        
    return 0;   
}

